-- THIS FILE IS PART OF PROJECT WORKBENCH
-- NAvigationExample.Lua - An example of entity navigate through wayp points.

-- Copyright (c) 2018 Project Workbench

local NavigationExample = 
{

    Properties = 
    {

		-- to store all the way points
		wayPoint = { EntityId() },	
		
		-- the number of the way points 
		--[todo] maybe can be replaced by getting array length? not familiar with the related functions
		wayPointNum = 0;		
		
		-- to store the information of the current way point
		CurrentPoint = 0;
    },
}


function NavigationExample: OnActivate()

	
	
	-- Tell the navigation component to start navigating.
	self.navHandler = NavigationComponentNotificationBus.Connect(self, self.entityId)
	
	-- Navigate to the first way point in the array
    NavigationComponentRequestBus.Event.FindPathToEntity(self.entityId, self.Properties.wayPoint[0])

	self.Properties.CurrentPoint = 1;
	

	
end





function NavigationExample:OnTraversalStarted(requestId)
   
end

function NavigationExample:OnTraversalComplete(requestId)

	-- to get the current way point and calculate which is the next way point and navigate to it
	local i = 0
	while i < self.Properties.wayPointNum do
	
		
		if(math.fmod(self.Properties.CurrentPoint, self.Properties.wayPointNum) == i)then
	
			NavigationComponentRequestBus.Event.FindPathToEntity(self.entityId, self.Properties.wayPoint[i]);	
	
		end
		i = i + 1;
	
	end	
	self.Properties.CurrentPoint = self.Properties.CurrentPoint + 1;
end

function NavigationExample: OnDeactivate()

	Debug.Log("Deactivate");

end

return NavigationExample;